local mod = ...



-- *************************************************************************************************************
-- Controller -------------------------------------------------------------------------------------
-- Removes stumpS after some time
-- *************************************************************************************************************

local COMP_STUMP_CONTROLLER = {
	TypeName = "COMP_STUMP_CONTROLLER",
	ParentType = "COMPONENT",
	Properties = {
    }
}


-- Init
function COMP_STUMP_CONTROLLER:onEnabled()

    -- Daily script
    local compMainGameLoop = self:getLevel():find("COMP_MAIN_GAME_LOOP")
    event.register(self, compMainGameLoop.ON_NEW_DAY, function()

        -- Loop through all stumps
        local listDelete = {}
        self:getLevel():getComponentManager("COMP_STUMP"):getAllEnabledComponent():forEach(function(compStump)

            -- mod:log("Stump " .. tostring(compStump:getOwner():getId()) .. ", DaysLeft " .. compStump.DaysLeft)

            compStump.DaysLeft = compStump.DaysLeft - 1
            if compStump.DaysLeft < 0 then
                table.insert(listDelete, compStump:getOwner())
            end

        end)

        -- Delete any that were tagged (can't do that in the loop above or it cuts short the daily event)
        for i = 1, #listDelete do
            if listDelete[i] then
                listDelete[i]:destroy()
            end
        end

    end)

end


-- Register custom Class
mod:registerClass(COMP_STUMP_CONTROLLER)


-- Assign to Prefab
mod:registerPrefabComponent("PREFAB_MANAGER", { DataType = "COMP_STUMP_CONTROLLER" } )

